Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# AnimInterface Class Reference

This is the fundamental interface for things that have a play/loop/stop type interface for frame-based animation, such as animated characters. More...

Inheritance diagram for AnimInterface:

List of all members.

## Public Member Functions
double | getFrac ()
| Returns the fractional part of the current frame.
int | getFrame ()
| Returns the current integer frame number.
double | getFrameRate ()
| Returns the native frame rate of the animation.
double | getFullFframe ()
| Returns the current floating-point frame number.
int | getFullFrame ()
| Returns the current integer frame number.
int | getNextFrame ()
| Returns the current integer frame number + 1, constrained to the range 0 <= f < get_num_frames().
int | getNumFrames ()
| Returns the number of frames in the animation.
double | getPlayRate ()
| Returns the rate at which the animation plays.
bool | isPlaying ()
| Returns true if the animation is currently playing, false if it is stopped (e.g.
| loop (bool restart)
| Starts the entire animation looping.
| loop (bool restart, double from, double to)
| Loops the animation from the frame "from" to and including the frame "to", indefinitely.
| output (ostream out)
| pingpong (bool restart)
| Starts the entire animation bouncing back and forth between its first frame and last frame.
| pingpong (bool restart, double from, double to)
| Loops the animation from the frame "from" to and including the frame "to", and then back in the opposite direction, indefinitely.
| play (double from, double to)
| Runs the animation from the frame "from" to and including the frame "to", at which point the animation is stopped.
| play ()
| Runs the entire animation from beginning to end and stops.
| pose (double frame)
| Sets the animation to the indicated frame and holds it there.
| setPlayRate (double play_rate)
| Changes the rate at which the animation plays.
| stop ()
| Stops a currently playing or looping animation right where it is.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This is the fundamental interface for things that have a play/loop/stop type interface for frame-based animation, such as animated characters.

This is the base class for AnimControl and other, similar classes.

## Member Function Documentation

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented in VideoTexture, AnimControl, and SequenceNode.

double getFrac | ( |  | ) |

Returns the fractional part of the current frame.

Normally, this is in the range 0.0 <= f < 1.0, but in the one special case of an animation playing to its end frame and stopping, it might exactly equal 1.0.

It will always be true that get_full_frame() + get_frac() == get_full_fframe().

int getFrame | ( |  | ) |

Returns the current integer frame number.

This number will be in the range 0 <= f < get_num_frames().

double getFrameRate | ( |  | ) |

Returns the native frame rate of the animation.

This is the number of frames per second that will elapse when the play_rate is set to 1.0. It is a fixed property of the animation and may not be adjusted by the user.

double getFullFframe | ( |  | ) |

Returns the current floating-point frame number.

Unlike the value returned by get_frame(), this frame number may extend beyond the range of get_num_frames() if the frame range passed to play(), loop(), etc. did.

Unlike the value returned by get_full_frame(), this return value may equal (to_frame + 1.0), when the animation has played to its natural end. However, in this case the return value of get_full_frame() will be to_frame, not (to_frame + 1).

int getFullFrame | ( |  | ) |

Returns the current integer frame number.

Unlike the value returned by get_frame(), this frame number may extend beyond the range of get_num_frames() if the frame range passed to play(), loop(), etc. did.

Unlike the value returned by get_full_fframe(), this return value will never exceed the value passed to to_frame in the play() method.

int getNextFrame | ( |  | ) |

Returns the current integer frame number + 1, constrained to the range 0 <= f < get_num_frames().

If the play mode is PM_play, this will clamp to the same value as get_frame() at the end of the animation. If the play mode is any other value, this will wrap around to frame 0 at the end of the animation.

int getNumFrames | ( |  | ) |

Returns the number of frames in the animation.

This is a property of the animation and may not be directly adjusted by the user (although it may change without warning with certain kinds of animations, since this is a virtual method that may be overridden).

Reimplemented in SequenceNode.

double getPlayRate | ( |  | ) |

Returns the rate at which the animation plays.

See set_play_rate().

bool isPlaying | ( |  | ) |

Returns true if the animation is currently playing, false if it is stopped (e.g.

because stop() or pose() was called, or because it reached the end of the animation after play() was called).

loop | ( | bool | restart | ) |

Starts the entire animation looping.

If restart is true, the animation is restarted from the beginning; otherwise, it continues from the current frame.

loop | ( | bool | restart,
|  | double | from,
|  | double | to
| ) |  |

Loops the animation from the frame "from" to and including the frame "to", indefinitely.

If restart is true, the animation is restarted from the beginning; otherwise, it continues from the current frame.

output | ( | ostream | out | ) |

Reimplemented in AnimControl.

pingpong | ( | bool | restart | ) |

Starts the entire animation bouncing back and forth between its first frame and last frame.

If restart is true, the animation is restarted from the beginning; otherwise, it continues from the current frame.

pingpong | ( | bool | restart,
|  | double | from,
|  | double | to
| ) |  |

Loops the animation from the frame "from" to and including the frame "to", and then back in the opposite direction, indefinitely.

play | ( | double | from,
|  | double | to
| ) |  |

Runs the animation from the frame "from" to and including the frame "to", at which point the animation is stopped.

Both "from" and "to" frame numbers may be outside the range (0, get_num_frames()) and the animation will follow the range correctly, reporting numbers modulo get_num_frames(). For instance, play(0, get_num_frames() * 2) will play the animation twice and then stop.

play | ( |  | ) |

Runs the entire animation from beginning to end and stops.

pose | ( | double | frame | ) |

Sets the animation to the indicated frame and holds it there.

setPlayRate | ( | double | play_rate | ) |

Changes the rate at which the animation plays.

1.0 is the normal speed, 2.0 is twice normal speed, and 0.5 is half normal speed. 0.0 is legal to pause the animation, and a negative value will play the animation backwards.

stop | ( |  | ) |

Stops a currently playing or looping animation right where it is.

The animation remains posed at the current frame.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties